<?php
/**
 * [BillyDroid_save_settings Save settings from theme-options]
 */
	function BillyDroid_save_settings( ) {

		// validate the request itself by verifying the _wpnonce from theme options
		if ( isset( $_POST['save']) && !empty($_POST['BillyDroid_save_opt']) ){
			if ( check_admin_referer( 'BillyDroid_save_settings','BillyDroid_save_opt' ) ) {
				foreach ( $_POST as $field => $value ) {
					switch ($field) {
						case 'BillyDroid_slider_options':
						case 'BillyDroid_slider_type':
						case 'BillyDroid_feat_responsiveness_slider':
						case 'BillyDroid_feat_caption_field_title_slider':
						case 'BillyDroid_feat_caption_field_date_slider':
						case 'BillyDroid_feat_caption_field_text_slider':
						case 'BillyDroid_feat_caption_field_author_slider':
						case 'BillyDroid_feat_thumb_position_slider':
						case 'slides':
							set_theme_mod ( $field, $value);
						break;
					}
					
				}
				// validate the request itself by verifying the _wpnonce-custom-header-options nonce
				$goback = add_query_arg( 'settings-updated', 'true', wp_get_referer() );
				wp_redirect( $goback );
				exit;
			}
		}
	}
add_action( 'admin_init', 'BillyDroid_save_settings' );
?>