<?php
	function slidr_markup( $feat=false ){

		$slider_info = get_theme_settings( 'slider_info' );
		extract( $slider_info );
		extract( $slider_opt );
		$thumbs = array ();
		ob_start();
		?>
			<script>
				jQuery(function(){
					jQuery('.wtsCarousel').carousel({
						interval: 5000
					});
				});
			</script>

			<style>
			.wtsCarousel{
				height:<?php echo $height_slider-20; ?>px;
				width:<?php echo $width_slider; ?>px;
			}
			.wrapper_slider .carousel-inner{
				-webkit-box-shadow: 0 0 3px rgba(0, 0, 0, .5);
				-moz-box-shadow: 0 0 3px rgba(0, 0, 0, .5);
				box-shadow: 0 0 3px rgba(0, 0, 0, .5);
			}
			</style>
			<div id="wptg_Carousel2" class="carousel wtsCarousel slide " >
				<!-- Carousel items -->
				<div id="tgcarousel_container" class="carousel-inner">
					<?php 
					if ( empty($feat) ):
						$featp = new WP_Query( array( 'post_type' => 'post', 'posts_per_page' => -1) );
						$counter_post=0;
						if( $featp->have_posts() ) : while ( $featp->have_posts() ) : $featp->the_post();
						$feat_post = get_post_meta( get_the_ID(), 'feat_post', true);
							if($feat_post == 'on'): $counter_post++;?>
								<div class="item <?php echo($counter_post == 1?"active":"");?>">
									<div class="contentSlide">
									<?php 
										the_post_thumbnail();
										$thumbs[] = get_the_post_thumbnail( get_the_ID(), 'BillyDroid_slides_th' );
										if ( $titl_slider == 'true' ):
									?>
										<h1><a href="<?php the_permalink();?>"><?php the_title();?></a></h1>
									<?php 
										endif;
									?>
										<div class="post_icon_sld" >
										<!--start to show more info-->
										<?php 
											if( $date_slider == 'true' ):
										?>
											<span class="post_date post_icon"><?php _e('On ','BillyDroid'); ?> <?php the_time("M j, Y ");?></span>
										<?php
											endif;
											if( $auth_slider == 'true'):
										?>
											<span class="post_author post_icon"><?php _e('By','BillyDroid'); ?> <?php the_author();?></span>
										<?php
											endif;
											if( $text_slider=='true'){
												the_excerpt();
											}
										?>
										</div>
										<a class="more-link" href="<?php the_permalink();?>">
											<span class="more-link_right"></span>
											<?php _e(' Read More','BillyDroid');?>
											<span class="more-link_left"></span>
										</a>
								</div>
							</div>
							<?php
								endif;
							endwhile;
						endif; 
						wp_reset_query();
					else: 
						$slides = get_theme_settings( 'slides' );
						foreach ( $slides as $index => $attach ) {

							extract( $attach );
							if ( empty ($attachment) )
								continue;

							$thumbs[] = wp_get_attachment_image( $attachment, 'BillyDroid_slides_th' );

							switch ( $type_slider ){
								case 'random':
								case 'random-top':
								case 'random-relative':
								case 'random-medium':
									$imgurl = wp_get_attachment_image ( $attachment, 'BillyDroid_slides_HD');
								break;
								default:
									$imgurl = wp_get_attachment_image( $attachment, 'BillyDroid_slides');
									$attr ='width="'.$width_slider.'" height="'. $height_slider.'"';
								break;
							}

							?>
								<div class="item <?php echo($index == 1?"active":"");?>">
									<a href="<?php echo $url;?>"> <?php echo $imgurl; ?> </a>
								</div>
							<?php
						}
					endif;
					?>

			  	</div>
			  	  	<!-- Carousel nav -->
					<a class="carousel-control left rs-prev goto-slide ts-arrow-1 ts-arrow-1-left nivo-prevNav" href="#wptg_Carousel2" data-rs="prev" data-slide="prev" id="prev"></a>
					<a class="carousel-control right rs-next goto-slide ts-arrow-1 ts-arrow-1-right nivo-nextNav" href="#wptg_Carousel2" data-rs="next" data-slide="next" id="next"></a>
		  	</div>
		<?php
		$slider_html = ob_get_clean();

		return  compact('slider_html', 'thumbs');
	}
?>
