<?php 
	/*Footer settings*/
	$wp_customize->add_section( 'BillyDroid_footer_options', array(
		'title'          => __( 'Footer Info', 'BillyDroid' ),
		'priority'       => 39,
		'description'	 => __( 'You can write your company information in this area. This will be automatically added to the footer. Use &lt;br /&gt; to break lines', 'BillyDroid' )
	) );
	/*Logo type*/
	$wp_customize->add_setting('BillyDroid_theme_options[footer_info]', array(
		'default'           => $options['footer_info'],
		'capability'        => 'edit_theme_options',
		'transport'			=> 'postMessage'
	));
	$wp_customize->add_control(
		new Textarea_Custom_Control( 
			$wp_customize,
			'textarea_setting',
			array(
			'label'   =>  __( 'Footer Information', 'BillyDroid' ),
			'section' => 'BillyDroid_footer_options',
			'settings'   => 'BillyDroid_theme_options[footer_info]',
			)
		)
	);

?>