<?php 
		$wp_customize->add_section( 'BillyDroid_global_options', array(
			'title'          => __( 'General options', 'BillyDroid' ),
			'priority'       => 35,
			'description'	 => __( 'Set elements to show theme', 'BillyDroid' )
		) );
		/* Sets responsive mode*/
		$wp_customize->add_setting('BillyDroid_theme_options[responsive]', array(
			'default'           => $options['responsive'],
			'capability'        => 'edit_theme_options',
			'transport'			=> 'postMessage',
		));
		$wp_customize->add_control( 'BillyDroid_body_options_responsive', array(
			'label'    => __( 'Responsive design theme', 'BillyDroid' ),
			'section'  => 'BillyDroid_global_options',
			'settings' => 'BillyDroid_theme_options[responsive]',
			'type'    => 'checkbox',
			'priority' => 4,
			
		) );
		/* Sets display  main menu*/		
		$wp_customize->add_setting('BillyDroid_theme_options[menu_show]', array(
			'default'           => $options['menu_show'],
			'capability'        => 'edit_theme_options',
			'transport'			=> 'postMessage',
		));
		$wp_customize->add_control( 'BillyDroid_body_options_menu_show', array(
			'label'    => __( 'Show main menu', 'BillyDroid' ),
			'section'  => 'BillyDroid_global_options',
			'settings' => 'BillyDroid_theme_options[menu_show]',
			'type'    => 'checkbox',
			'priority' => 5,
			
		) );
		/* Sets display Topbar menu*/
		$wp_customize->add_setting('BillyDroid_theme_options[topbar_show]', array(
			'default'           => $options['topbar_show'],
			'capability'        => 'edit_theme_options',
			'transport'			=> 'postMessage',
		));
		$wp_customize->add_control( 'BillyDroid_body_options_topbar_show', array(
			'label'    => __( 'Show top bar menu', 'BillyDroid' ),
			'section'  => 'BillyDroid_global_options',
			'settings' => 'BillyDroid_theme_options[topbar_show]',
			'type'    => 'checkbox',
			'priority' => 6,
			
		) );
		/* Sets display search box*/
		$wp_customize->add_setting('BillyDroid_theme_options[search_show]', array(
			'default'           => $options['search_show'],
			'capability'        => 'edit_theme_options',
			'transport'			=> 'postMessage',
		));
		$wp_customize->add_control( 'BillyDroid_body_options_search_show', array(
			'label'    => __( 'Show search box', 'BillyDroid' ),
			'section'  => 'BillyDroid_global_options',
			'settings' => 'BillyDroid_theme_options[search_show]',
			'type'    => 'checkbox',
			'priority' => 7,
			
		) );
?>