<?php 
		$wp_customize->add_section( 'BillyDroid_postdisplay_options', array(
			'title'          => __( 'Post Display Options', 'BillyDroid' ),
			'priority'       => 37,
			'description'	 => __( 'Setting for Post Display', 'BillyDroid' )
		) );
		/* Post display mode*/
		$wp_customize->add_setting('BillyDroid_theme_options[post_display]', array(
			'default'           => $options['post_display'],
			'capability'        => 'edit_theme_options',
			'transport'			=> 'postMessage',
		));
		$wp_customize->add_control( 'BillyDroid_body_options_post_display', array(
			'label'    => __( 'Post display mode', 'BillyDroid' ),
			'section'  => 'BillyDroid_postdisplay_options',
			'settings' => 'BillyDroid_theme_options[post_display]',
			'type'    => 'radio',
			'choices' => $post_display_mode,
			'priority' => 5,
			
		) );
		/* Grid size mode*/
		$wp_customize->add_setting('BillyDroid_theme_options[post_size]', array(
			'default'           => $options['post_size'],
			'capability'        => 'edit_theme_options',
			'transport'			=> 'postMessage',
		));
		$wp_customize->add_control( 'BillyDroid_body_options_post_size', array(
			'label'    => __( 'Grid size (only apply, if display mode grid is enabled)', 'BillyDroid' ),
			'section'  => 'BillyDroid_postdisplay_options',
			'settings' => 'BillyDroid_theme_options[post_size]',
			'type'    => 'radio',
			'choices' => $grid_size,
			'priority' => 6,
			
		) );
		/* Box style */
		$wp_customize->add_setting('BillyDroid_theme_options[post_style]', array(
			'default'           => $options['post_style'],
			'capability'        => 'edit_theme_options',
			'transport'			=> 'postMessage',
		));
		$wp_customize->add_control( 'BillyDroid_body_options_post_style', array(
			'label'    => __( 'Set your style box for you theme', 'BillyDroid' ),
			'section'  => 'BillyDroid_postdisplay_options',
			'settings' => 'BillyDroid_theme_options[post_style]',
			'type'	   => 'select',
			'choices'  => $box_style,
			'priority' => 7,
			
		) );

?>