<?php 

function BillyDroid_slider_schemes() {

	$slider_options = array(
					  'No-Slider'=>'No Slider',
					  'Nivo-Slider' => array( 
									 'name' => 'Effects slider',
									 'anim_speed' => '500',
									 'effects' => array( 
													'random',
													'sliceDownRight',
													'sliceDownLeft',
													'sliceUpRight',
													'sliceUpLeft',
													'sliceUpDown',
													'sliceUpDownLeft',
													'fold',
													'fade',
													'boxRandom',
													'boxRain',
													'boxRainReverse',
													'boxRainGrow',
													'boxRainGrowReverse'
									 )
					  ),
					  'Easy-Accordion' => 'Accordion Slider',
					  'Piecemaker' => array( 
								 	  'name' => '3D slider',
								 	  'delay' => '10',
								 	  'effects' => array(
												   'linear',
												   'easeInQuad',
												   'easeOutQuad',
												   'easeInOutQuad',
												   'easeInCubic',
												   'easeOutCubic',
												   'easeInOutCubic',
												   'easeInQuart',
												   'easeOutQuart',
												   'easeInOutQuart',
												   'easeInQuint',
												   'easeOutQuint',
												   'easeInOutQuint',
												   'easeInSine',
												   'easeOutSine',
												   'easeInOutSine',
												   'easeInExpo',
												   'easeOutExpo',
												   'easeInOutExpo',
												   'easeInCirc',
												   'easeOutCirc',
												   'easeInOutCirc',
												   'easeInElastic',
												   'easeOutElastic',
												   'easeInOutElastic',
												   'easeInBack',
												   'easeOutBack',
												   'easeInOutBack',
												   'easeInBounce',
												   'easeOutBounce',
												   'easeInOutBounce'
									  )
					  ),
					  'Featured-Slider' => array(
										   'name' => 'Featured Posts Slider',
										   'effects' => array( 
										   "default",
										   "cubeH",
										   "cubeV",
										   "fade"
										   ),
					  ),
					  'fade' => 'Fading Transition',
					  'sliceV' => 'Vertical Slice Slider',
					  'slideV' => 'Vertical Slide Slider'
	);
	/*
	 * options for slides front end
	 */
	return apply_filters( 'BillyDroid_slider_schemes', $slider_options );
}

/**
 * [BillyDroid_sidebar_schemes load ]
 */
function BillyDroid_sidebar_schemes () {

	/// Layouts position
	$sidebar_positions = array( 'top_1' ,
							'top_2',
							'left_1',
							'left_2',
							'right_1',
							'right_2',
							'bottom_1',
							'bottom_2' );

	return apply_filters( 'BillyDroid_sidebar_schemes', $sidebar_positions );
}
/**
 * [get_template_sidebar get the markup of the widgets]
 * @return [ array() ] [ return the args with settings register sidebars ]
 */

function BillyDroid_get_template_sidebar () {

	$register_sidebar = array(
		'name' => '',
	  	'description' => 'Widgets in this area will be shown Pages Selected',
		'before_widget' => '<div class="boxes">
		<div class="container_widgets_pieces">
	  	<div class="widget_corner widget_top_left"><div class="widget_token_left"></div></div>
	  	<div class="widget_topbottom widget_top_center"></div>
	  	<div class="widget_corner widget_top_right"><div class="widget_token_right"></div></div>
	  	<div class="widget_sides widget_middle_left"></div>
	  	<div class="widget_center widget_content">',
		'after_widget' => '</div>
 		<div class="widget_sides widget_middle_right"></div>
	  	<div class="widget_corner widget_bottom_left"></div>
	  	<div class="widget_topbottom widget_bottom_center"></div>
	  	<div class="widget_corner widget_bottom_right"></div>
		</div><!-- end container_widgets_pieces -->
		<div class="widget_token_bottom"></div>
  		</div><!-- end boxes -->',
	  	'before_title' => '<h3>',
	  	'after_title' => '</h3>'
	);
	return apply_filters( 'BillyDroid_get_template_sidebar', $register_sidebar );
}

function slider_border_schemes () {

	$pfx_border = 'tg-border-';
	$border_style = array( $pfx_border.'default' => ' default');
	foreach ( range(1, 23) as $number)
		$border_style[ $pfx_border.$number ] = $number;

	return apply_filters( 'slider_border_schemes' ,$border_style);
}


?>