<?php 
/*Carga estilos css de  contenido*/
function BillyDroid_header_style() {

	?>
		<style type="text/css">
		<?php 
		?>
		.container_menu ul ul{
			display:none;
		}
		@import url(<?php echo get_template_directory_uri(); ?>/framework-tool/current_layout/last_change.css);
		</style>	
		<style type="text/css" id="custom_heading" >
				.navbar{
					display: none;
				}
			<?php
				$BillyDroid_settings = get_theme_settings();
				$fontFamilyTagP = $BillyDroid_settings['body_fontfamily'];
				$fontSizeTagP = $BillyDroid_settings['body_fontsize'];
				$fontColorTagP = $BillyDroid_settings['body_color'];
				$fontFamilyTagHeading = $BillyDroid_settings['Headings_fontfamily'];
				if($fontFamilyTagP != 'inherit' || $fontSizeTagP != 'inherit' || $fontColorTagP != 'Inherit'){?>
					body .body_theme{<?php
						echo ($fontFamilyTagP != 'inherit')?'font-family: "'.$fontFamilyTagP.'", Arial, Helvetica, serif;':'';
						echo ($fontSizeTagP != 'inherit')?'font-size: '.$fontSizeTagP.';':'';
						echo ($fontColorTagP != 'inherit')?'color: '.$fontColorTagP.';':'';?>
					}<?php
				}
				if($fontFamilyTagHeading != 'inherit'){?>
					body .body_theme h1, body .body_theme h2, body .body_theme h3, body .body_theme h4, body .body_theme h5, body .body_theme h6{
						font-family: "<?php echo $fontFamilyTagHeading; ?>", Arial, Helvetica, serif;
					}<?php
				}
				foreach(range(1, 6) as $heading){

					$heading_font_size = "H{$heading}_fontsize";
					$heading_color = "H{$heading}_color";
					$fontSizeTagH = $BillyDroid_settings[ $heading_font_size ];
					$fontColorTagH = $BillyDroid_settings[ $heading_color ];
					echo ($fontSizeTagH != 'inherit')?'body .body_theme h'.$heading.'{font-size: '.$fontSizeTagH.'px;}':'';
					echo ($fontColorTagH != 'Inherit')?'body .body_theme h'.$heading.'{color: '.$fontColorTagH.';}':'';
				}
				if ($BillyDroid_settings['logo_mode']=='text'):
					$logo_fontfamily=($BillyDroid_settings['logo_fontfamily']!='inherit')?'font-family:'.$BillyDroid_settings['logo_fontfamily'].', sans-serif;':'';
					$logo_fontsize=($BillyDroid_settings['logo_fontsize']!='inherit')?'font-size:'.$BillyDroid_settings['logo_fontsize']:'';
					if (!empty($logo_fontfamily) or !empty($logo_fontsize)):
				?>
						body .logo{
							<?php 
								echo $logo_fontfamily."\n"; 
								echo $logo_fontsize;
							?>
						}
				<?php
					endif;
				endif;
				echo ($BillyDroid_settings['logo_footer']===true)?'':'#footer .logo{ display:none; }';// show logo in the footer
				?>
				/*Esto se va para base_template.css */
				body .logo[data-mode="text"] img {
					display:none;
				}
				body .logo[data-mode="image"] .logotext{
					display:none;
				}
				body .post_icon[data-show="false"], body .comments_link[data-show="false"]{
					display:none;
				}
				body .comments_link[data-show="true"]{
					display:block;
				}
				<?php 

					if ( BillyDroid_responsive_slider() ){
						
						$feat_style = $BillyDroid_settings['slider_info']['opt']['border_style'];
						if( $feat_style != 'tg-border-default' ){
							/*height in responsive mode*/
							$height_slider = $BillyDroid_settings['slider_info']['opt']['height_slider'];
							/*width for the slider*/
							$width_slider = $BillyDroid_settings['slider_info']['opt']['width_slider'];
							//responsive slider
							$res_slider = get_theme_mod( 'BillyDroid_feat_responsiveness_slider' );
						}

						/*wts slider show*/
						/*responsively actions*/
						if( isset( $res_slider ) && $res_slider=='yes' ){?>
							.slider_area{
								height:<?php echo $height_slider;?>px ;
								width:<?php echo ($height_slider+($height_slider/0.7));?>px ;/* !important46.35%*/
							}
						<?php
						}
					}
				?>
		</style>
	<?php

}
add_action('wp_head','BillyDroid_header_style');


function BillyDroid_scripts_styles() {
	/*
	 * Adds JavaScript to pages with the comment form to support
	 * sites with threaded comments (when in use).
	 */
	// Loads the Internet Explorer specific stylesheet.
	$responsive = get_theme_settings('responsive');
	wp_enqueue_style( 'tgc-ier', get_template_directory_uri() . '/css/reset.ie.css', array(), '2013-10-31' );
	wp_style_add_data( 'tgc-ier', 'conditional', 'lt IE' );
	wp_enqueue_style( 'tgc-ie7', get_template_directory_uri() . '/css/ie7.css',array(), '2013-10-31' );
	wp_style_add_data( 'tgc-ie7', 'conditional', 'lte IE 9' );
	wp_enqueue_style( 'tgc-fontawesome', get_template_directory_uri() . '/css/font-awesome-logo.css',array(), '2013-10-31' );
	$tgc_mediaq=($responsive !== true )?'':'(min-width: 960px)';
	wp_enqueue_style( 'tgc-mediaquery', get_template_directory_uri() . '/css/mainmenu.css',array(), '2013-10-31' ,$tgc_mediaq);
		wp_enqueue_style( 'tgc-theme', get_stylesheet_uri() ,array(), '2.0' );
	wp_enqueue_style( 'tgc-refineslider', get_template_directory_uri(). '/css/refineslide.css' ,array(), '2013-10-31' );
	if( true === $responsive) {

		//responsive between 600 a 960
		wp_enqueue_style( 'tgc-theme-ripad', get_template_directory_uri().'/css/responsive-medium.css' ,array(), '2013-10-31','screen and (min-width: 600px) and (max-width: 960px), screen and (min-device-width: 600px) and (max-device-width: 760px) and (orientation:landscape)' );
		//responsive between 120 a 599
		wp_enqueue_style( 'tgc-theme-rmobile', get_template_directory_uri().'/css/responsive-small.css' ,array(), '2013-10-31','screen and (min-width: 120px) and (max-width: 599px), screen and (min-device-width: 120px) and (max-device-width: 599px)' );
	}
		wp_enqueue_script('tg-nivoslider', get_template_directory_uri().'/js/jquery.nivo.slider.js',array('jquery'),'1.4',true);
		wp_enqueue_script('tg-colorbox', get_template_directory_uri().'/js/colorbox.js',array('jquery'),'1.4.21',true);
		wp_enqueue_script('tg-modernizr', get_template_directory_uri().'/js/modernizr.js',array('jquery'),'1.4.21',true);
		wp_enqueue_script('tg-smartgallery', get_template_directory_uri().'/js/jquery.smartgallery.js',array('jquery'),'1',true);
		wp_enqueue_script('tg-refineslide', get_template_directory_uri().'/js/jquery.refineslide.js',array('jquery'),'1',true);
		wp_enqueue_script('tg-wpts_slider_multiple', get_template_directory_uri().'/js/wpts_slider_multiple.js',array('jquery'),'1.5',true);
		wp_enqueue_script('tg-scheduler', get_template_directory_uri().'/js/scheduler.js',array('jquery'),'1.26',true);		
		wp_enqueue_script('tg-autoscroll', get_template_directory_uri().'/js/jquery_autoscroll.js',array('jquery'),'1',true);
		wp_enqueue_script('tg-carousel', get_template_directory_uri().'/js/carousel.js',array('jquery'),'1',true);
		wp_enqueue_script('tg-featured_thumbnail', get_template_directory_uri().'/js/featured_thumbnail.js',array('jquery'),'1',true);
		wp_enqueue_script('jquery-masonry');
		wp_enqueue_script('tg-menu', get_template_directory_uri().'/js/menu.js',array('jquery'),'2013-10-31',true);
		wp_enqueue_script('tg-kwicks', get_template_directory_uri().'/js/jquery.kwicks.js',array('jquery'),'2013-10-31',true);
		wp_enqueue_script('tg-bootstrap', get_template_directory_uri().'/js/bootstrap.min.js',array('jquery'),'2.3.3',true);
		wp_enqueue_script('tg-tooltip-popover', get_template_directory_uri().'/js/auto_tooltip_popover.js',array('jquery'),'2.0.1',true);
		wp_enqueue_script('tg-boxslider', get_template_directory_uri().'/js/box_slider.jquery.js',array('jquery'),'1.0',true);
}

add_action( 'wp_enqueue_scripts', 'BillyDroid_scripts_styles' );
?>