<?php 
/**
 * [print_markup_input print the markup for theme-option depending type slider need ]
 * @param  [array] $args [ attributes for the input, if you are aused select must be add option_values ]
 * @return [void]       [ only print the current markup ]
 */
	function print_markup_input ( $args ) {
			if ( !is_array ( $args ) )
				return;

			extract( $args );
		?>
			<div class="inside-row">
				<div class="display-table-cell table-cell-first">
				  <label for="<?php echo $name; ?>"><?php echo  $label_name; ?></label>
				</div>
				<div class="display-table-cell table-cell-2">
					<?php 
						switch ($type) {
							case 'radio':
								foreach ( $option_values as $key => $val) :

									$id = $id_prefix.$val;
									$attr= "name = '{$name}' class = '{$name}' id = '{ $id }' value = '{$val}' ";
									if ( $key == $value )
										$attr .= 'checked ';
							
								?>
							<input type="radio" <?php echo $attr; ?> >
							<label for="<?php  echo $id; ?>" class="button" style="border-radius:4px 0 0 4px;margin-left:4px;">Yes</label>
								<?php 
								endforeach;
							break;
							case 'select':
								if ( empty ($attr) )
									$attr = '';
								?>
								<select name="<?php echo $name; ?>" id="<?php echo $name; ?>" <?php echo $attr; ?>>
									<?php 

										foreach ( $option_values as $key => $val) {

											$attr = "value = '{$key}' ";

											if ( is_array( $val ) ) {
												if ( isset( $val['sldpack'] ) )
												$attr .= "data-pack = '{$val['sldpack']}' ";

											} else {
												$attr .= "data-pack = 'none' ";
											}

											if ( $key== $value)
												$attr .= "selected";
											?>
											<option <?php echo $attr; ?> > <?php  echo is_array( $val )?$val['name']:$val; ?> </option>
											<?php
										}
									?>
								</select>
								<?php
							break;
							default:
								?>
									<input name="<?php echo $name ?>" id="<?php echo $name; ?>" type="text" value="<?php echo $value; ?>" />
								<?php
							break;
						}
					?>

				</div>
			</div><!-- end inside-row -->
		<?php
	}
?>